part of grapheen;

abstract class Replication {
	Grapheen _g;
	List<List> _queue = new List();
	void addToQueue(bool vertex,int id, String key, Object value) {
		_queue.add([vertex,id,key,value]);
	}
	int _nextObjectId = -1;
	int newObjectId() {
		return _nextObjectId--;
	}
	Replication(this._g) {
	}
	Future replicate() async {
		// collect negative Ids from queue
		List<int> negatives = new List();
		_queue.forEach((List event) {
			if (event[1] > 0)
				return;
			if (negatives.contains(event[1]))
				return;
			negatives.add(event[1]);
		});
		List<int> newids;
		if (negatives.length>0) {
			// call_reserveIds
			newids = await call_reserveIds(negatives.length);
		}
		// prepare input snapshot and clear indexer from negative objects
		String input = "";
		_queue.forEach((List event) {
			int id = event[1];
			if (id<0) {
				if (event[0] == true)
					_g._v.set(id,event[2],null);
				else
					_g._e.set(id,event[2],null);
				id = newids[negatives.indexOf(id)];
			}
			Object value = event[3];
			if (event[0] == false && event[2] == "_from" && value<0) {
				value = newids[negatives.indexOf(value)];
			}
			if (event[0] == false && event[2] == "_to" && value<0) {
				value = newids[negatives.indexOf(value)];
			}
			input += (event[0] ? "V," : "E,")+id.toString()+","+event[2]+",";
			if (value is String) {
				value = value.replaceAll("'","\\'");
				input += "'"+value+"'";
			}
			else
				input += value.toString();
			input += "\n";
		});
		_queue = new List();
		// call_replicate
		String result = await call_replicate(input);

		// fill in replicate data to engine
		_g.loadGraph(result);
	}
	///////////////////////////////////////////////////////////////////////////////
	///
	/// will return list of new IDs to be used by engine
	///
	Future<List<int>> call_reserveIds(int cnt);
	///
	/// as an input there is a dump of new events
	/// as an output, there is a list of events to be consumed by engine
	///
	Future<String> call_replicate(String input);

}