part of grapheen;

class _Pipe implements Pipe {
	Grapheen _g;
	_Pipe _prev;

	// exact pipe constructor
	_Pipe(this._g,this._prev);

	Pipe V([var idOrKey, var value]) {
		if (idOrKey is int) {
			return new _PipeIds(_g,this,[idOrKey]);
		} else if (idOrKey is String) {
			return new _PipeQ(_g,this,idOrKey,"=",value);
		}
		return this;
	}
	Pipe E([var idOrKey, var value]) {
		if (idOrKey is int) {
			return new _PipeIds(_g,this,[idOrKey]);
		}
		return null;
	}
	Pipe inE([String name]) {
		return new _PipeInOutE(_g,this,true,false,name);
	}
	Pipe inV() {
		return new _PipeInOutV(_g,this,true,false);
	}
	Pipe outE([String name]) {
		return new _PipeInOutE(_g,this,false,true,name);
	}
	Pipe outV() {
		return new _PipeInOutV(_g,this,false,true);
	}
	Pipe bothE([String name]) {
		return new _PipeInOutE(_g,this,true,true,name);
	}
	Pipe bothV() {
		return new _PipeInOutV(_g,this,true,true);
	}
	Pipe has(String key,var value) {
		return new _PipeQ(_g,this,key,"=",value);
	}
	Pipe hasNot(String key,var value) {
		return new _PipeQ(_g,this,key,"!=",value);
	}
	Pipe dedup() {
		return new _PipeDedup(_g,this);
	}
	Pipe order(String key) {
		return new _PipeOrder(_g,this,key);
	}


	Map map() {
		List<int> resids = ids();
		if (resids.length>0) {
			return new Map.from(_g._getObject(resids[0]));
		}
		return null;
	}
	bool setProperty(String name,var value) {
		List<int> resids = ids();
		List recs = new List();
		resids.forEach((int id) {
			//TODO: need to check object type
			_g._set(true,id,name,value);
		});
		return true;
	}
	bool remove() {
		List<int> resids = ids();
		List recs = new List();
		resids.forEach((int id) {
			Map obj = new Map.from(_g._getObject(id));
			obj.keys.forEach((String prop) {
				//TODO: need to check object type
				_g._set(true,id,prop,null);
			});
		});
		return true;
	}
	List ids() {
		return null;
	}
}

